"use strict";

import React                    from 'react';
import assets                   from '../libs/assets';
import Request                  from 'superagent';
import _                        from 'lodash';

class Home extends React.Component {
  constructor(){
    super();
    this.state = {};
  }

  componentWillMount(){
    //called the first time the component is loaded right beforet he component is added to the page
    this.search();
  }

  componentDidMount(){
    //Called after the component has been rendered into the page
  }

  componentWillReceiveProps(nextProps){
    //Called when the props provided to the component are changed
  }

  componentWillUpdate(nextProps, nextState){
    //Called when the props and/or state change
  }

  componentWillUnmount(){
    //Called when the component is removed
  }

  updateSearch(){
    this.search(this.refs.query.value);
  }

  render(){
    var CustomRow = React.createClass({
      render: function(){
        return (
          <tr>
            <td id="movieTitle">{this.props.Title}</td>
            <td>{this.props.Year}</td>
            <td>{this.props.imdbID}</td>
            <td>{this.props.Type}</td>
            <td><img height="200" width="200" src={this.props.Poster} /></td>
          </tr>
        );
      }
    });

    var movies = _.map(this.state.movies, (movie, i) => {
      return <CustomRow key={i} Title={movie.Title} Year={movie.Year} imdbID={movie.imdbID} Type={movie.Type} Poster={movie.Poster}/>;
    });
    return <div>
      Search For Movies/TV Shows With:<input ref="query" onChange={ (e) => { this.updateSearch(); } } type="text" />
      <table>
        <thead>
          <tr>
            <td>Title</td>
            <td>Year</td>
            <td>IMDB ID</td>
            <td>Type</td>
            <td>Poster</td>
          </tr>
        </thead>
        <tbody>
            {movies}
        </tbody>
      </table>
    </div>;
  }

  search(query = "walking dead"){
    var url = 'http://www.omdbapi.com?s=' + query + '&y=&r=json&plot=short';
    Request.get(url).then((response) => {
      this.setState({
        movies: response.body.Search,
        total: response.body.totalResults
      });
    });
  }

}

export { 
  Home as default 
};